// #autoload
// #name        = AdvSuicide
// #version     = 1.0
// #date        = 3.5.03
// #author      = Evita
// #web         = http://scripts.tribalwar.com/evita/
// #description = Uses your repair kit, drops all your stuff, deploys a mine, then suicides.		  
// #category    = Evitas Scripts
// #config      = SuicideConfig


if(isFile("prefs/EvPrefs.cs") && !$EvPrefsLoaded) {

  	exec("prefs/EvPrefs.cs");
 	$EvPrefsLoaded = true;
}

if(!isObject(Suicide)) {

  	new ScriptObject(Suicide) {

    	  class   = Suicide;
    	  version = "1.0";
  	};
} 

function Suicide::Setup(%this) {

	if(%this.setup)
	  return;

new GuiControl(SuicideConfig) {

	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellPaneProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "121 62";
		extent = "382 299";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "AdvSuicide";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";
	};
	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "144 94";
		extent = "337 246";
		minExtent = "16 18";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
	};
	new ShellToggleButton(SuicideKit) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "239 146";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$EvPrefs::Suicide::Kit";
		helpTag = "0";
		text = "Use Repair Kit";
		longTextBuffer = "0";
		maxLength = "255";
	};
	new ShellToggleButton(SuicidePack) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "239 178";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$EvPrefs::Suicide::Pack";
		helpTag = "0";
		text = "Throw Pack";
		longTextBuffer = "0";
		maxLength = "255";
	};
	new ShellToggleButton(SuicideWeapons) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "239 210";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$EvPrefs::Suicide::Weapons";
		helpTag = "0";
		text = "Throw Weapons";
		longTextBuffer = "0";
		maxLength = "255";
	};
	new ShellToggleButton(SuicideAmmo) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "239 242";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$EvPrefs::Suicide::Ammo";
		helpTag = "0";
		text = "Throw Ammo";
		longTextBuffer = "0";
		maxLength = "255";
	};
	new ShellToggleButton(SuicideItems) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "239 274";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$EvPrefs::Suicide::Items";
		helpTag = "0";
		text = "Throw Items";
		longTextBuffer = "0";
		maxLength = "255";
	};
	new ShellToggleButton(SuicideMine) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "239 306";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$EvPrefs::Suicide::Mine";
		helpTag = "0";
		text = "Deploy Mine";
		longTextBuffer = "0";
		maxLength = "255";
	};
};

		SuicideKit.setValue($EvPrefs::Suicide::Kit);
		SuicidePack.setValue($EvPrefs::Suicide::Pack);
		SuicideWeapons.setValue($EvPrefs::Suicide::Weapons);
		SuicideAmmo.setValue($EvPrefs::Suicide::Ammo);
		SuicideItems.setValue($EvPrefs::Suicide::Items);
		SuicideMine.setValue($EvPrefs::Suicide::Mine);

		%this.setup = true;
}

package Suicide {

function SuicideStart() {

	Suicide.AntiScavenge();
}

function Suicide::AntiScavenge(%this) {

	if($EvPrefs::Suicide::Kit)
	%this.UseKit();

	if($EvPrefs::Suicide::Pack)
	%this.ThrowPack();

	if($EvPrefs::Suicide::Weapons)
	%this.updateSchedule = %this.schedule(100, ThrowWeapons);

	if($EvPrefs::Suicide::Mine)
	%this.updateSchedule = %this.schedule(300, DeployMine);

	if($EvPrefs::Suicide::Ammo)
	%this.updateSchedule = %this.schedule(500, ThrowAmmo);

	if($EvPrefs::Suicide::Items)
	%this.updateSchedule = %this.schedule(700, ThrowItems);

	%this.updateSchedule = %this.schedule(800, Suicide);
}

function Suicide::DeployMine() {

      commandToServer( 'endThrowCount' );
      $mvTriggerCount5++;
}

function Suicide::UseKit() {

	useRepairKit(1);
}

function Suicide::Suicide() {

	suicide(1);
}

function Suicide::ThrowPack() {

	throwPack(1);
}

function Suicide::ThrowWeapons() {

	throw(Blaster);
	throw(Plasma);
	throw(Chaingun);
	throw(Disc);
	throw(GrenadeLauncher);
	throw(Mortar);
	throw(ELFGun);
	throw(SniperRifle);
	throw(Shocklance);
	throw(MissileLauncher);
}

function Suicide::ThrowAmmo() {

	throw(PlasmaAmmo);
	throw(ChaingunAmmo);
	throw(DiscAmmo);
	throw(GrenadeLauncherAmmo);
	throw(MortarAmmo);
	throw(MissileLauncherAmmo);
}

function Suicide::ThrowItems() {

	throw(RepairKit);
	throw(Grenade);
	throw(Mine);
	throw(Beacon);
}

function OptionsDlg::onWake(%this) {

	if (!Suicide.bind) {

		$RemapName[$RemapCount] = "Suicide";
		$RemapCmd[$RemapCount]  = "SuicideStart";
		$RemapCount++;
		
		Suicide.bind = true;
	}
	
	parent::onWake(%this);
}

function quit() {

	if(!$EvPrefsSaved) {

		export("$EvPrefs::*", "prefs/EvPrefs.cs", false);
		$EvPrefsSaved = true;
	}

	parent::quit();
}

};

activatePackage(Suicide);

Suicide::Setup(%this);